
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>actions &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Backend servers" href="vcl-backends.html" />
    <link rel="prev" title="Request and response VCL objects" href="vcl-variables.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="vcl-backends.html" title="Backend servers"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="vcl-variables.html" title="Request and response VCL objects"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" accesskey="U">VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">actions</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="actions">
<span id="user-guide-vcl-actions"></span><h1>actions<a class="headerlink" href="#actions" title="Permalink to this headline">¶</a></h1>
<p>The most common actions to return are these:</p>
<dl class="simple">
<dt><em>pass</em></dt><dd><p>When you return pass the request and subsequent response will be passed to
and from the backend server. It won’t be cached. <cite>pass</cite> can be returned from
<cite>vcl_recv</cite>.</p>
</dd>
<dt><em>hash</em></dt><dd><p>When you return hash from <cite>vcl_recv</cite> you tell Varnish to deliver content
from cache even if the request otherwise indicates that the request
should be passed.</p>
</dd>
</dl>
<p><em>pipe</em></p>
<dl class="simple">
<dt><em>deliver</em></dt><dd><p>Deliver the object to the client. Usually returned from <cite>vcl_backend_response</cite>.</p>
</dd>
<dt><em>restart</em></dt><dd><p>Restart processing of the request. You can restart the processing of
the whole transaction. Changes to the <cite>req</cite> object are retained, except
for <cite>req.backend_hint</cite>, which gets reset to the default backend.</p>
</dd>
<dt><em>retry</em></dt><dd><p>Retry the request against the backend. This can be returned from
<cite>vcl_backend_response</cite> or <cite>vcl_backend_error</cite> if you don’t like the response
that the backend delivered.</p>
</dd>
</dl>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="vcl-variables.html"
                        title="previous chapter">Request and response VCL objects</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="vcl-backends.html"
                        title="next chapter">Backend servers</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/users-guide/vcl-actions.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="vcl-backends.html" title="Backend servers"
             >next</a> |</li>
        <li class="right" >
          <a href="vcl-variables.html" title="Request and response VCL objects"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" >VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">actions</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>